function UnderHood:InitializeAlphaEngine()
	self:RegisterEvent( "PLAYER_TARGET_CHANGED", "UpdateAlpha" )
	self:RegisterEvent( "PLAYER_FOCUS_CHANGED", "UpdateAlpha" )
	self:RegisterEvent( "UNIT_HEALTH", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_MANA", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_ENERGY", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_RAGE", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_RUNIC_POWER", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_PET", "UpdateAlphaIfPlayer" )

	self:RegisterEvent( "UNIT_SPELLCAST_START", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_STOP", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_FAILED", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_DELAYED", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_INTERRUPTED", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_CHANNEL_START", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_CHANNEL_UPDATE", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_CHANNEL_STOP", "UpdateAlphaIfPlayer" )
	self:RegisterEvent( "UNIT_SPELLCAST_CHANNEL_INTERRUPTED", "UpdateAlphaIfPlayer" )
end

function UnderHood:UpdateAlphaIfPlayer( event, unit )
	if unit ~= "player" then return end

	self:UpdateAlpha()
end

function UnderHood:UpdateAlpha()
	self.globalAlpha = self:CalculateAlpha( self.db.profile.alpha )
	
	for k, v in self:IterateFrames() do
		v:UpdateAlpha()
	end
end

function UnderHood:CalculateAlpha( settings )
	local alpha
	local pt = UnitPowerType( "player" )

	if self.configMode then
		alpha = 1
	elseif self.inCombat then
		alpha = settings.combat
	elseif settings.enableTarget and UnitExists( "target" ) then
		alpha = settings.target
	elseif settings.enableFocus and UnitExists( "focus" ) then
		alpha = settings.focus
	elseif settings.enablePet and UnitExists( "pet" ) then
		alpha = settings.pet
	elseif settings.enableRegen and
			(
				UnitHealth( "player" ) ~= UnitHealthMax( "player" ) or -- All classes
				(pt == 0 and UnitMana( "player" ) ~= UnitManaMax( "player" )) or -- Casters
				(pt == 1 and UnitMana( "player" ) > 0) or -- Warriors and Bear-druids
				(pt == 3 and UnitMana( "player" ) ~= UnitManaMax( "player" )) -- Rogues and Cat-druids
			) then
		alpha = settings.regen
	elseif settings.enableCasting and (UnitCastingInfo( "player" ) or UnitChannelInfo( "player" )) then
		alpha = settings.casting
	else
		alpha = settings.ooc
	end

	return alpha
end
